lots of fixes, new music stuff
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262
263
264
265 mysrc() {
266 local path dir file
267 path=$1
268 dir=${path%/*}
269 file=${path##*/}
270 if [[ -s $path ]]; then
271 source $path
272 elif [[ -s $bashrc_dir/$file ]]; then
273 source $bashrc_dir/$file
274 fi
275 }
276
277
278 mysrc /a/bin/small-misc-bash/ll-function
279 mysrc /a/bin/distro-functions/src/package-manager-abstractions
280
281
282 # * functions
283
284 ### begin FSF section ###
285
286 # Comments before functions are meant to be good useful
287 # documentation. If they fail at that, please improve them or send Ian a
288 # note.
289
290 ## copy bash completion
291 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
292 #
293 # It copies how the bash completion works from one command to other
294 # commands.
295 ccomp() {
296 local c src
297 src=$1
298 shift
299 if ! c=$(complete -p $src 2>/dev/null); then
300 _completion_loader $src &>/dev/null ||:
301 c=$(complete -p $src 2>/dev/null) || return 0
302 fi
303 # remove $src( .*|$)
304 c=${c% $src}
305 c=${c%% $src *}
306 eval $c $*
307 }
308
309 ## directory history tracking and navigation.
310 #
311 # cd becomes a function, also aliased to c. b to go back, f to go
312 # forward, cl to list recent directories and choose one.
313 #
314 # The finer details you may want to skip:
315 #
316 # We also define bl to print the list of back and forward directories.
317 #
318 # We keep 2 stacks, forward and back. Unlike with a web browser, the
319 # forward stack is not erased when going somewhere new.
320 #
321 # Recent directories are stored in ~/.cdirs.
322 #
323 declare -a _dir_forward _dir_back
324 c() {
325 # normally, the top of _dir_back is our current dir. if it isn't,
326 # put it on there, except we don't want to do that when we
327 # just launched a shell
328 if [[ $OLDPWD ]]; then
329 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
330 _dir_back+=("$PWD")
331 fi
332 fi
333 command cd "$@"
334 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
335 _dir_back+=("$PWD")
336 fi
337 echo "$PWD" >> ~/.cdirs
338 }
339 ccomp cd c
340
341 # back
342 b() {
343 local top_back
344 if (( ${#_dir_back[@]} == 0 )); then
345 echo "nothing left to go back to" >&2
346 return 0
347 fi
348 top_back="${_dir_back[-1]}"
349
350 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
351 echo "already on last back entry" >&2
352 return 0
353 fi
354
355
356 if [[ $top_back == "$PWD" ]]; then
357 # add to dirf if not already there
358 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
359 _dir_forward+=("$top_back")
360 fi
361 unset "_dir_back[-1]"
362 command cd "${_dir_back[-1]}"
363 else
364 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
365 _dir_forward+=("$PWD")
366 fi
367 command cd "$top_back"
368 fi
369
370 # Interesting feature, not sure I want it.
371 # give us a peek at what is next in the list
372 # if (( ${#_dir_back[@]} >= 2 )); then
373 # printf "%s\n" "${_dir_back[-2]}"
374 # fi
375 #
376
377 # c/b/f Implementation notes:
378 #
379 # The top of the back is $PWD
380 # as long as the last directory change was due to c,b,or cl.
381 #
382 # Example of stack changes:
383 #
384 # a b c (d)
385 ## back
386 # a b (c)
387 # d
388 #back
389 #a (b)
390 #d c
391 #back
392 #(a)
393 #d c b
394 #forward
395 #a (b)
396 #d c
397 #
398 # a b c
399 ## back
400 # a b
401 # (c)
402 ## forward
403
404 }
405 # forward
406 f() {
407 local top_forward
408 if (( ${#_dir_forward[@]} == 0 )); then
409 echo "no forward dir left" >&2
410 return 0
411 fi
412 top_forward="${_dir_forward[-1]}"
413 unset "_dir_forward[-1]"
414 c "$top_forward"
415
416 # give us a peek at what is next in the list
417 # if (( ${#_dir_forward[@]} )); then
418 # printf "%s\n" "${_dir_forward[-1]}"
419 # fi
420 }
421 # cd list
422 cl() {
423 local i line input start
424 local -A buttondirs alines
425 local -a buttons dirs lines
426 buttons=( {a..z} {2..9} )
427 if [[ ! -s ~/.cdirs ]]; then
428 echo nothing in ~/.cdirs
429 return 0
430 fi
431
432 i=0
433
434 mapfile -t lines <~/.cdirs
435 start=$(( ${#lines[@]} - 1 ))
436
437 # we have ~33 buttons as of this writing, so lets
438 # prune down the history every once in a while.
439 if (( start > 500 )); then
440 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
441 fi
442
443 for (( j=$start; j >= 0; j-- )); do
444 line="${lines[$j]}"
445 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
446 continue
447 fi
448 alines[$line]=t
449 buttondirs[${buttons[i]}]="$line"
450 printf "%s %s\n" ${buttons[i]} "$line"
451 if (( i == ${#buttons[@]} - 1 )); then
452 break
453 fi
454 i=$(( i + 1 ))
455 done
456
457 if (( i == 0 )); then
458 echo "no dirs in ~/.cdirs"
459 return 0
460 fi
461 read -r -N 1 input
462 if [[ $input != $'\n' ]]; then
463 c "${buttondirs[$input]}"
464 fi
465 }
466 # back list
467 bl() {
468 local start i j max
469 max=10
470 start=$(( ${#_dir_back[@]} - 1 ))
471
472 # cleanup possible repeating of pwd
473 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
474 start=$(( start - 1 ))
475 fi
476 j=1
477 if (( start >= 0 )); then
478 for (( i=$start; i >= 0 ; i-- )); do
479 printf "%s %s\n" $j ${_dir_back[i]}
480 j=$(( j + 1 ))
481 if (( j >= max )); then
482 break
483 fi
484 done
485 fi
486
487 max=10
488 start=$(( ${#_dir_forward[@]} - 1 ))
489
490 # cleanup possible repeating of pwd
491 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
492 start=$(( start - 1 ))
493 fi
494 if (( start < 0 )); then
495 return 0
496 fi
497 echo --
498 j=1
499 for (( i=$start; i >= 0 ; i-- )); do
500 printf "%s %s\n" $j ${_dir_forward[i]}
501 j=$(( j + 1 ))
502 if (( j >= max )); then
503 break
504 fi
505 done
506 }
507
508 # pee do. run args as a command with output copied to syslog.
509 #
510 # Usage: pd [-t TAG] COMMAND...
511 #
512 # -t TAG Override the tag in the syslog. The default is COMMAND with
513 # any path part is removed, eg. for /bin/cat the tag is cat.
514 #
515 # You can view the log via "journalctl -t TAG"
516 pd() {
517 local tag ret
518 ret=0
519 tag=${1##*/}
520 case $1 in
521 -t) tag="$2"; shift 2 ;;
522 esac
523 echo "PWD=$PWD command: $*" | logger -t $tag
524 "$@" |& pee cat "logger -t $tag" || ret=$?
525 echo "exited with status=$ret" | pee cat "logger -t $tag"
526 # this avoids any err-catch
527 (( $ret == 0 )) || return $ret
528 }
529 ccomp time pd
530
531 # jdo = journal do. Run command as transient systemd service, tailing
532 # its output in the journal until it completes.
533 #
534 # Usage: jdo COMMAND...
535 #
536 # Compared to pd: commands recognize this is a non-interactive shell.
537 # The service is unaffected if our ssh connection dies, no need to run
538 # in screen or tmux.
539 #
540 # Note: The last few lines of any existing entries for a unit by that
541 # name will be output first, and there will be a few second delay at the
542 # start of the command, and a second or so at the end.
543 #
544 # Note: Functions and aliases obviously won't work, we resolve the
545 # command to a file.
546 #
547 # Note: requires running as root.
548 jdo() {
549 local cmd cmd_name jr_pid ret
550 ret=0
551 cmd="$1"
552 shift
553 if [[ $EUID != 0 ]]; then
554 echo "jdo: error: rerun as root"
555 return 1
556 fi
557 cmd_name=${cmd##*/}
558 if [[ $cmd != /* ]]; then
559 cmd=$(type -P "$cmd")
560 fi
561 # -q = quiet
562 journalctl -qn2 -f -u "$cmd_name" &
563 # Trial and error of time needed to avoid missing initial lines.
564 # .5 was not reliable. 1 was not reliable. 2 was not reliable
565 sleep 4
566 jr_pid=$!
567 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
568 # The sleep lets the journal output its last line
569 # before the prompt comes up.
570 sleep .5
571 kill $jr_pid &>/dev/null ||:
572 unset jr_pid
573 fg &>/dev/null ||:
574 # this avoids any err-catch
575 (( $ret == 0 )) || return $ret
576 }
577 ccomp time jdo
578 #### end fsf section
579
580
581 ..() { c ..; }
582 ...() { c ../..; }
583 ....() { c ../../..; }
584 .....() { c ../../../..; }
585 ......() { c ../../../../..; }
586
587 chere() {
588 local f path
589 for f; do
590 path=$(readlink -e "$f")
591 echo "cat >$path <<'EOF'"
592 cat "$f"
593 echo EOF
594 done
595 }
596
597
598 # file cut copy and paste, like the text buffers :)
599 # I havnt tested these.
600 _fbufferinit() { # internal use
601 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
602 rm -rf "${my_f_tempdir:?}"/*
603 }
604 fcp() { # file cp
605 _fbufferinit
606 cp "$@" "$my_f_tempdir"/
607 }
608 fct() { # file cut
609 _fbufferinit
610 mv "$@" "$my_f_tempdir"/
611 }
612 fpst() { # file paste
613 [[ $2 ]] && { echo too many arguments; return 1; }
614 target=${1:-.}
615 cp "$my_f_tempdir"/* "$target"
616 }
617
618 _khfix_common() {
619 local host ip port file key
620 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
621 file=$(readlink -f ~/.ssh/known_hosts)
622 if [[ ! $ip ]]; then
623 echo "khfix: ssh failed"
624 return 1
625 fi
626 if [[ $port != 22 ]]; then
627 ip_entry="[$ip]:$port"
628 host_entry="[$host]:$port"
629 else
630 ip_entry=$ip
631 host_entry=$host
632 fi
633 tmpfile=$(mktemp)
634 if [[ $host != $ip ]]; then
635 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
636 if [[ $key ]]; then
637 grep -Fv "$key" "$file" | sponge "$file"
638 fi
639 fi
640 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
641 if [[ $key ]]; then
642 grep -Fv "$key" "$file" | sponge "$file"
643 fi
644 ll ~/.ssh/known_hosts
645 rootsshsync
646 }
647 khfix() { # known hosts fix
648 _khfix_common "$@" || return 1
649 ssh $1 :
650 }
651 khcopy() {
652 _khfix_common "$@"
653 ssh-copy-id $1
654 }
655
656 a() {
657 local x
658 x=$(readlink -nf "${1:-$PWD}")
659 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
660 echo -n "$x" | xclip -selection clipboard
661 echo -n "$x" | xclip
662 }
663
664 # a1 = awk {print $1}
665 for field in {1..20}; do
666 eval a$field"() { awk '{print \$$field}'; }"
667 done
668 # h1 = head -n1
669 for num in {1..9}; do
670 eval h$num"() { head -n$num; }"
671 done
672
673
674 hexipv4() {
675 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
676 }
677
678 vp9() {
679 local f out outdir in
680 outdir=vp9
681 case $1 in
682 --out)
683 outdir=$2
684 shift 2
685 ;;
686 esac
687 m mkdir -p $outdir
688 for f; do
689 out=$PWD/$outdir/$f
690 in=$PWD/$f
691 m cd $(mktemp -d)
692 pwd
693 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
694 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
695 cd -
696 done
697 }
698
699 utcl() { # utc 24 hour time to local hour 24 hour time
700 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
701 }
702
703 bwm() {
704 s bwm-ng -T avg -d
705 }
706
707
708 # for running in a fai rescue. iank specific.
709 kdrescue() {
710 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
711 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
712 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
713 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
714 done
715 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
716 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
717 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
718 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
719 cd /mnt
720 chrbind
721 }
722
723
724
725
726 c4() { c /var/log/exim4; }
727
728 caa() { git commit --amend --no-edit -a; }
729
730 cf() {
731 for f; do
732 hr
733 echo "$f"
734 hr
735 cat "$f"
736 done
737 }
738 caf() {
739 # shellcheck disable=SC2033
740 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
741 -o -name .hg -prune -o -name .editor-backups -prune \
742 -o -name .undo-tree-history -prune \) \
743 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
744
745 }
746 ccomp cat cf caf
747
748 calc() { echo "scale=3; $*" | bc -l; }
749 # no having to type quotes, but also no command history:
750 clc() {
751 local x
752 read -r x
753 echo "scale=3; $x" | bc -l
754 }
755
756 cam() {
757 git commit -am "$*"
758 }
759
760 ccat () { # config cat. see a config without extra lines.
761 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
762 }
763 ccomp grep ccat
764
765 chrbind() {
766 local d
767 # dev/pts needed for pacman signature check
768 for d in dev proc sys dev/pts; do
769 [[ -d $d ]]
770 if ! mountpoint $d &>/dev/null; then
771 m s mount -o bind /$d $d
772 fi
773 done
774 }
775 chumount() {
776 local d
777 # dev/pts needed for pacman signature check
778 for d in dev/pts dev proc sys; do
779 [[ -d $d ]]
780 if mountpoint $d &>/dev/null; then
781 m s umount $d
782 fi
783 done
784 }
785
786
787 _cdiff-prep() {
788 # join options which are continued to multiples lines onto one line
789 local first=true
790 while IFS= read -r line; do
791 # remove leading spaces/tabs. assumes extglob
792 if [[ $line == "[ ]*" ]]; then
793 line="${line##+( )}"
794 fi
795 if $first; then
796 pastline="$line"
797 first=false
798 elif [[ $line == *=* ]]; then
799 echo "$pastline" >> "$2"
800 pastline="$line"
801 else
802 pastline="$pastline $line"
803 fi
804 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
805 echo "$pastline" >> "$2"
806 }
807
808 cdiff() {
809 # diff config files,
810 # setup for format of postfix, eg:
811 # option = stuff[,]
812 # [more stuff]
813 local pastline unified f1 f2
814 unified="$(mktemp)"
815 f1="$(mktemp)"
816 f2="$(mktemp)"
817 _cdiff-prep "$1" "$f1"
818 _cdiff-prep "$2" "$f2"
819 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
820 while IFS= read -r line; do
821 # the default bright red / blue doesnt work in emacs shell
822 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
823 done < "$unified"
824 }
825
826
827 cat-new-files() {
828 local start=$SECONDS
829 local dir="$1"
830 # shellcheck disable=SC2030
831 inotifywait -m "$dir" -e create -e moved_to | \
832 while read -r filedir _ file; do
833 cat "$filedir$file"
834 hr
835 calc $((SECONDS - start)) / 60
836 sleep 5
837 done
838
839 }
840
841 chownme() {
842 s chown -R $USER:$USER "$@"
843 }
844
845 # shellcheck disable=SC2032
846 chown() {
847 # makes it so chown -R symlink affects the symlink and its target.
848 if [[ $1 == -R ]]; then
849 shift
850 command chown -h "$@"
851 command chown -R "$@"
852 else
853 command chown "$@"
854 fi
855 }
856
857 cim() {
858 git commit -m "$*"
859 }
860
861
862 d() { builtin bg "$@"; }
863 ccomp bg d
864
865 dc() {
866 diff --strip-trailing-cr -w "$@" # diff content
867 }
868 ccomp diff dc
869
870 despace() {
871 local x y
872 for x in "$@"; do
873 y="${x// /_}"
874 safe_rename "$x" "$y"
875 done
876 }
877
878 # df progress
879 # usage: dfp MOUNTPOINT [SECOND_INTERVAL]
880 # SECOND_INTERVAL defaults to 90
881 dfp() {
882 # mp = mountpoint
883 local a b mp interval
884 mp=$1
885 interval=${2:-90}
886 if [[ ! $mp ]]; then
887 echo "dfp: error, missing 1st arg" >&2
888 return 1
889 fi
890 while true; do
891 a=$(df --output=used $mp | tail -n1)
892 sleep $interval
893 b=$(df --output=used $mp | tail -n1)
894 printf "used mib: %'d mib/min: %s\n" $(( b /1000 )) $(( (b-a) / (interval * 1000 / 60 ) ))
895 done
896 }
897
898 # get ipv4 ip from HOST. or if it is already a number, return that
899 hostip() {
900 local host="$1"
901 case $host in
902 [0-9:])
903 echo "$host"
904 ;;
905 *)
906 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
907 ;;
908 esac
909 }
910
911 dig() {
912 command dig +nostats +nocmd "$@"
913 }
914 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
915 digsort() {
916 local sec
917 sec=
918 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
919 if [[ $l == [^\;]* ]]; then
920 sec+="$l"$'\n'
921 else
922 if [[ $sec ]]; then
923 printf "%s" "$sec" | sort
924 sec=
925 fi
926 printf "%s\n" "$l"
927 fi
928 done
929 }
930 ccomp dig digsort
931 # compare digs to the 2 servers
932 # usage: digdiff @server1 @server2 DIG_ARGS
933 # note: only the soa master nameserver will respond with
934 # ra "recursive answer" flag. That difference is meaningless afaik.
935 digdiff() {
936 local s1 s2
937 s1=$1
938 shift
939 s2=$1
940 shift
941 digsort $s1 "$@" | tee /tmp/digdiff
942 diff -u /tmp/digdiff <(digsort $s2 "$@")
943 }
944
945 dt() {
946 date "+%A, %B %d, %r" "$@"
947 }
948 dtr() {
949 date -R "$@"
950 }
951 ccomp date dt dtr
952
953 dus() { # du, sorted, default arg of
954 du -sh ${@:-*} | sort -h
955 }
956 ccomp du dus
957
958
959 e() { printf "%s\n" "$*"; }
960
961 # echo args
962 ea() {
963 if (( ! $# )); then
964 echo no args
965 fi
966 for arg; do
967 printf "%qEOL\n" "${arg}"
968 printf "%s" "${arg}" |& hexdump -C
969 done
970 }
971
972 # echo variables. print var including escapes, etc, like xxd for variable
973 ev() {
974 if (( ! $# )); then
975 echo no args
976 fi
977 for arg; do
978 if [[ -v $arg ]]; then
979 printf "%qEOL\n" "${!arg}"
980 printf "%s" "${!arg}" |& hexdump -C
981 else
982 echo arg $arg is unset
983 fi
984 done
985 }
986
987 ediff() {
988 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
989 emacs --eval "(ediff-files \"$1\" \"$2\")"
990 }
991
992 # mail related
993 etail() {
994 ngset
995 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
996 ngreset
997 }
998 etailm() {
999 tail -F /var/log/exim4/mainlog -n 200 "$@"
1000 }
1001 etail2() {
1002 tail -F /var/log/exim4/mymain -n 200 "$@"
1003 }
1004 ccomp tail etail etail2
1005
1006
1007
1008
1009 # print exim old pids
1010 eoldpids() {
1011 local configtime pid piduptime now daemonpid
1012 printf -v now '%(%s)T' -1
1013 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
1014 if [[ -s /run/exim4/exim.pid ]]; then
1015 daemonpid=$(cat /run/exim4/exim.pid)
1016 fi
1017 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
1018 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
1019 if [[ $pid == $daemonpid ]]; then
1020 continue
1021 fi
1022 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
1023 if (( configtime > now - piduptime )); then
1024 echo $pid
1025 fi
1026 done
1027 }
1028
1029 # exim tail but only watch lines from new pids
1030 etailnew() {
1031 local pid oldpids
1032 for pid in $(eoldpids); do
1033 oldpids+="$pid|"
1034 done
1035 if [[ $oldpids ]]; then
1036 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1037 else
1038 etail
1039 fi
1040 }
1041 # exim watch as old pids go away
1042 ewatchold() {
1043 local configtime pid piduptime now
1044 local -i count
1045 local -a oldpids
1046 count=0
1047 while true; do
1048 oldpids=($(eoldpids))
1049 if (( ! ${#oldpids[@]} )); then
1050 return
1051 fi
1052 # print the date every 20 iterations
1053 if (( ! count % 20 )); then
1054 date
1055 fi
1056 count+=1
1057 ps -f -p "${oldpids[*]}"
1058 sleep 1
1059 done
1060 }
1061
1062 eless() {
1063 less /var/log/exim4/mainlog
1064 }
1065 ccomp less eless
1066 eqcat() {
1067 exiqgrep -ir.\* -o 60 | while read -r i; do
1068 hlm exim -Mvc $i
1069 echo
1070 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1071 done
1072 }
1073 eqrmf() {
1074 # other ways to get the list of message ids:
1075 # exim -bp | awk 'NF == 4 {print $3}'
1076 # # this is slower 160ms, vs 60.
1077 # exipick -i
1078 exiqgrep -ir.\* | xargs exim -Mrm
1079 }
1080
1081 econfdevnew() {
1082 rm -rf /tmp/edev
1083 mkdir -p /tmp/edev/etc
1084 cp -ra /etc/exim4 /tmp/edev/etc
1085 cp -ra /etc/alias* /tmp/edev/etc
1086 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1087 econfdev
1088 }
1089 econfdev() {
1090 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1091 }
1092
1093
1094
1095
1096 fa() {
1097 # find array. make an array of file names found by find into $x
1098 # argument: find arguments
1099 # return: find results in an array $x
1100 while read -rd ''; do
1101 x+=("$REPLY");
1102 done < <(find "$@" -print0);
1103 }
1104
1105 faf() { # find all files. use -L to follow symlinks
1106 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1107 -o -name .hg -prune -o -name .editor-backups -prune \
1108 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1109 }
1110
1111 # full path without resolving symlinks
1112 fp() {
1113 local dir base
1114 base="${1##*/}"
1115 dir="${1%$base}"
1116 printf "%s/%s\n" $(cd $dir; pwd) "$base"
1117 }
1118
1119
1120 # mail related
1121 frozen() {
1122 rm -rf /tmp/frozen
1123 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1124 sudo exim -Mvl $id
1125 echo
1126 sudo exim -Mvh $id
1127 echo
1128 sudo exim -Mvb $id
1129 echo -e '\n\n##############################\n'
1130 done | tee -a /tmp/frozen
1131 }
1132 frozenrm() {
1133 local ids=()
1134 while read -r line; do
1135 printf '%s\n' "$line"
1136 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
1137 done < <(s mailq)
1138 echo "sleeping for 2 in case you change your mind"
1139 sleep 2
1140 sudo exim -Mrm "${ids[@]}"
1141 }
1142
1143 funce() {
1144 # like -e for functions. returns on error.
1145 # at the end of the function, disable with:
1146 # trap ERR
1147 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1148 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1149 trap ERR
1150 return' ERR
1151 }
1152
1153 getdir () {
1154 local help="Usage: getdir [--help] PATH
1155 Output the directory of PATH, or just PATH if it is a directory."
1156 if [[ $1 == --help ]]; then
1157 echo "$help"
1158 return 0
1159 fi
1160 if [[ $# -ne 1 ]]; then
1161 echo "getdir error: expected 1 argument, got $#"
1162 return 1
1163 fi
1164 if [[ -d $1 ]]; then
1165 echo "$1"
1166 else
1167 local dir
1168 dir="$(dirname "$1")"
1169 if [[ -d $dir ]]; then
1170 echo "$dir"
1171 else
1172 echo "getdir error: directory does not exist"
1173 return 1
1174 fi
1175 fi
1176 }
1177
1178 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1179 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1180 local root
1181 root=$(gitroot) || return 1 # function to set gitroot
1182 builtin cd "$root"
1183 git symbolic-ref HEAD refs/heads/$1
1184 rm .git/index
1185 git clean -fdx
1186 }
1187
1188 # shellcheck disable=SC2120
1189 gitroot() {
1190 local help="Usage: gitroot [--help]
1191 Print the full path to the root of the current git repo
1192
1193 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1194 and works in older versions of git which did not have that."
1195 if [[ $1 == --help ]]; then
1196 echo "$help"
1197 return
1198 fi
1199 local p
1200 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1201 [[ $p != /* ]] && p=$PWD
1202 echo "${p%%/.git}"
1203 }
1204
1205 g() {
1206
1207 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1208 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1209
1210 local args gdb=false
1211
1212 if [[ $EMACSDIR ]]; then
1213 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1214 fi
1215
1216 if [[ $DISPLAY ]]; then
1217 args=-n
1218 fi
1219
1220 if (( $# == 0 )); then
1221 args+=" -c"
1222 fi
1223 # duplicate -c, but oh well
1224 if ! pgrep -u $EUID emacsclient; then
1225 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1226 gdb=true
1227 else
1228 args+=" -c"
1229 fi
1230 fi
1231 if [[ $EMACSDIR ]]; then
1232 # Alter the path here, otherwise the nfs mount gets triggered on the
1233 # first path lookup when emacs is not being used.
1234 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1235 else
1236 if $gdb; then
1237 # due to a bug, we cant debug from the start unless we get a new gdb
1238 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1239 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1240 m emacsclient -a "" $args "$@"
1241 sleep 1
1242 cd /a/opt/emacs-$(distro-name)$(distro-num)
1243 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1244 cd -
1245 else
1246 m emacsclient -a "" $args "$@"
1247 fi
1248 fi
1249 }
1250
1251 # force terminal version
1252 gn() {
1253 g -n "$@"
1254 }
1255
1256 gmacs() {
1257 # quit will prompt if the program crashes.
1258 gdb -ex=r -ex=quit --args emacs "$@"; r;
1259 }
1260
1261 gdkill() {
1262 # kill the emacs daemon
1263 pk1 emacs --daemon
1264 }
1265
1266 gr() {
1267 grep -iIP --color=auto "$@" || return $?
1268 }
1269 grr() { # grep recursive
1270 # Don't return 1 on nonmatch because this is meant to be
1271 # interactive, not in a conditional.
1272 if [[ ${#@} == 1 ]]; then
1273 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1274 else
1275 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1276 fi
1277 }
1278 ccomp grep gr grr
1279
1280 rg() { grr "$@"; }
1281 ccomp grep rg
1282
1283 hr() { # horizontal row. used to break up output
1284 printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
1285 echo
1286 }
1287 # highlight
1288 hl() {
1289 local col input_len=0
1290 for arg; do
1291 input_len=$((input_len + 1 + ${#arg}))
1292 done
1293 col=$((60 - input_len))
1294 printf "\e[1;97;41m%s" "$*"
1295 if (( col > 0 )); then
1296 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1297 fi
1298 echo
1299 }
1300 hlm() { hl "$*"; "$@"; }
1301
1302 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1303
1304
1305 # get latest hub and run it
1306 # main command to use:
1307 # hub pull-request --no-edit
1308 # --no-edit means to use the first commit\'s message as the pull request message.
1309 # If that fails, try doing
1310 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1311 # where branch is usually master. it does the pr against your current branch.
1312 #
1313 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1314 # it\'s at ~/.config/hub
1315 hub() {
1316 local up uptar updir p v
1317 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1318 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1319 re='[[:space:]]'
1320 if [[ ! $up || $up == $re ]]; then
1321 echo "failed to get good update url. got: $up"
1322 fi
1323 uptar=${up##*/}
1324 updir=${uptar%.tgz}
1325 if [[ ! -e /a/opt/$updir ]]; then
1326 rm -rf /a/opt/hub-linux-amd64*
1327 wget -P /a/opt $up
1328 tar -C /a/opt -zxf /a/opt/$uptar
1329 rm -f /a/opt/$uptar
1330 fi
1331 if ! which hub &>/dev/null; then
1332 sudo /a/opt/$updir/install
1333 fi
1334
1335 # save token across computers
1336 if [[ ! -L ~/.config/hub ]]; then
1337 if [[ -e ~/.config/hub ]]; then
1338 mv ~/.config/hub /p/c/subdir_files/.config/
1339 fi
1340 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1341 conflink
1342 fi
1343 fi
1344 command hub "$@"
1345 }
1346
1347 i() { git "$@"; }
1348 ccomp git i
1349
1350 # git status:
1351 # cvs -qn update
1352
1353 # git checkout FILE
1354 # cvs update -C FILE
1355
1356 # git pull
1357 # cvs up[date]
1358
1359 # potentially useful command translation
1360 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1361
1362 # importing cvs repo into git using git-cvs package:
1363 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1364
1365 ic() {
1366 # fast commit all
1367 git commit -am "$*"
1368 }
1369
1370 ipp() {
1371 git pull
1372 git push
1373 }
1374
1375
1376 ifn() {
1377 # insensitive find
1378 # -L = follow symlinks
1379 find -L . -not \( -name .svn -prune -o -name .git -prune \
1380 -o -name .hg -prune -o -name .editor-backups -prune \
1381 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1382 }
1383
1384 ifd() {
1385 # insensitive find directory
1386 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1387 -o -name .hg -prune -o -name .editor-backups -prune \
1388 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1389 }
1390
1391
1392 ipdrop() {
1393 sudo iptables -A INPUT -s $1 -j DROP
1394 }
1395
1396
1397 istext() {
1398 grep -Il "" "$@" &>/dev/null
1399 }
1400
1401 pst() {
1402 pstree -apnA
1403 }
1404
1405 jtail() {
1406 journalctl -n 10000 -f "$@"
1407 }
1408 jr() { journalctl "$@" ; }
1409 jrf() { journalctl -f "$@" ; }
1410 jru() {
1411 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1412 }
1413
1414
1415
1416 l() {
1417 if [[ $PWD == /[iap] ]]; then
1418 command ls -A --color=auto -I lost+found "$@"
1419 else
1420 command ls -A --color=auto "$@"
1421 fi
1422 }
1423
1424 lcn() { locate -i "*$**"; }
1425
1426 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1427
1428 lt() { ll -tr "$@"; }
1429
1430 lld() { ll -d "$@"; }
1431
1432 ccomp ls l lg lt lld ll
1433
1434 # low recursively
1435 lowr() {
1436 local f dirs i a
1437 local -a all
1438 for dirs in false true; do
1439 for f; do
1440 if [[ -d $f ]]; then
1441 all=("$f"/**)
1442 # reverse the order to rename the nested dirs first.
1443 # note: 0 element is the dir itself
1444 for ((i=${#all[@]}-1; i>=1; i--)); do
1445 a="${all[i]}"
1446 if $dirs && [[ -d $a ]]; then
1447 # e dirs low "$a" # debug
1448 low "$a"
1449 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1450 # debug
1451 # e not dirs low "$a" # debug
1452 low "$a"
1453 fi
1454 done
1455 fi
1456 # just rename all the top level args on the second pass
1457 if $dirs; then
1458 # e final dirs low "$f" # debug
1459 low "$f"
1460 fi
1461 done
1462 done
1463 }
1464
1465 low() { # make filenames lowercase, remove bad chars
1466 local arg new dir f
1467 for arg; do
1468 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1469 dir="${arg%/*}"
1470 if (( ${#dir} == ${#arg} )); then
1471 dir=.
1472 fi
1473 f="${arg##*/}"
1474 new="${f,,}" # downcase
1475 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1476 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1477 new="${new%"${new##*[[:alnum:]]}"}"
1478 # remove bad underscores, like __ and _._
1479 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1480 safe_rename "$dir/$f" "$dir/$new" || return 1
1481 done
1482 return 0
1483 }
1484
1485 lower() { # make first letter of filenames lowercase.
1486 local x
1487 for x in "$@"; do
1488 if [[ ${x::1} == [A-Z] ]]; then
1489 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1490 safe_rename "$x" "$y" || return 1
1491 fi
1492 done
1493 }
1494
1495
1496 k() { # history search
1497 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1498 }
1499 ks() { # history search with context
1500 # args are an extended regex used by sed
1501 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1502 }
1503 ksu() { # history search unique
1504 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1505 }
1506
1507 # todo: id like to do maybe a daily or hourly cronjob to
1508 # check that my history file size is increasing. Ive had it
1509 # inexplicably truncated in the past.
1510 histrm() {
1511 history -n
1512 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1513 read -p "press anything but contrl-c to delete"
1514 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1515 history -d $entry
1516 done
1517 history -w
1518 }
1519
1520 ccomp grep k ks ksu histrm
1521
1522
1523 make-targets() {
1524 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1525 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1526 }
1527
1528 mkc() {
1529 mkdir "$1"
1530 c "$1"
1531 }
1532 ccomp mkdir mkc
1533
1534 mkct() {
1535 mkc $(mktemp -d)
1536 }
1537
1538 mkt() { # mkdir and touch file
1539 local path="$1"
1540 mkdir -p "$(dirname "$path")"
1541 touch "$path"
1542 }
1543
1544 # shellcheck disable=SC2032
1545 mkdir() { command mkdir -p "$@"; }
1546
1547 nags() {
1548 # https://github.com/HenriWahl/Nagstamon/issues/357
1549 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1550 /usr/lib/notification-daemon/notification-daemon &
1551 fi
1552 /usr/bin/nagstamon &
1553 }
1554
1555 nmt() {
1556 # cant use s because sudo -i doesnt work for passwordless sudo command
1557 case $EUID in
1558 0)
1559 sudo nmtui-connect "$@"
1560 ;;
1561 *)
1562 nmtui-connect "$@"
1563 ;;
1564 esac
1565 }
1566
1567
1568 ngset() {
1569 if shopt nullglob >/dev/null; then
1570 ngreset=false
1571 else
1572 shopt -s nullglob
1573 ngreset=true
1574 fi
1575 }
1576 ngreset() {
1577 if $ngreset; then
1578 shopt -u nullglob
1579 fi
1580 }
1581
1582 nopanic() {
1583 # shellcheck disable=SC2024
1584 ngset
1585 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1586 base=${f##*/}
1587 if [[ -s $f ]]; then
1588 echo ================== $f =============
1589 s tee -a /var/log/exim4/$base-archive <$f
1590 s truncate -s0 $f
1591 fi
1592 done
1593 ngreset
1594 }
1595
1596
1597 ping() { command ping -O "$@"; }
1598 p8() { ping "$@" 8.8.8.8; }
1599 p6() { ping6 "$@" 2001:4860:4860::8888; }
1600
1601 pkx() { # package extract
1602 local pkg cached tmp f
1603 c $(mktemp -d)
1604 pkg=$1
1605 # shellcheck disable=SC2012
1606 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1607 if [[ $cached ]]; then
1608 cp $cached .
1609 else
1610 aptitude download $pkg || return 1
1611 fi
1612 tmp=(*); f=${tmp[0]} # only 1 expected
1613 ex $f
1614 rm -f $f
1615 }
1616
1617 # pgrep and kill
1618 pk1() {
1619 local pid
1620 pid=($(pgrep -f "$*"))
1621 case ${#pid[@]} in
1622 1)
1623 # shellcheck disable=SC2128
1624 {
1625 ps -F $pid
1626 m kill $pid
1627 }
1628 ;;
1629 0) echo "no pid found" ;;
1630 *)
1631 ps -F ${pid[@]}
1632 ;;
1633 esac
1634 }
1635
1636 psg () {
1637 local x y help
1638 help="Usage: psg [--help] GREP_ARGS
1639 grep ps and output in a nice format"
1640 if [[ $1 == --help ]]; then
1641 echo "$help"
1642 return
1643 fi
1644 x=$(ps -eF)
1645 # final grep is because some commands tend to have a lot of trailing spaces
1646 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1647 if [[ $y ]]; then
1648 echo "$x" | head -n 1 || [[ $? == 141 ]]
1649 echo "$y"
1650 fi
1651 }
1652
1653 pubip() { curl -4s https://icanhazip.com; }
1654 pubip6() { curl -6s https://icanhazip.com; }
1655 whatismyip() { pubip; }
1656
1657
1658 q() { # start / launch a program in the backround and redir output to null
1659 "$@" &> /dev/null &
1660 }
1661
1662 # shellcheck disable=SC2120
1663 r() {
1664 if [[ $HISTFILE ]]; then
1665 history -a # save history
1666 fi
1667 trap ERR # this avoids a segfault
1668 exit ${1:0}
1669 # i had this redir, not sure why
1670 # exit "$@" 2>/dev/null
1671 }
1672
1673 # scp is insecure and deprecated.
1674 scp() {
1675 rsync --inplace "$@"
1676 }
1677 ccomp rsync scp
1678
1679 randport() {
1680 # available high ports are 1024-65535,
1681 # but lets skip things that are more likely to be in use
1682 python3 <<'EOF'
1683 import secrets
1684 print(secrets.SystemRandom().randrange(10002,65500))
1685 EOF
1686 }
1687
1688 # reapply bashrc
1689 reb() {
1690 source ~/.bashrc
1691 }
1692
1693 rl() {
1694 readlink -f "$@"
1695 }
1696 ccomp readlink rl
1697
1698 rsd() {
1699 # rsync, root is required to keep permissions right.
1700 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1701 # --no-times --delete
1702 # basically, make an exact copy, use checksums instead of file times to be more accurate
1703 rsync -ahvic --delete "$@"
1704 }
1705 rsa() {
1706 # like rlu, but dont delete files on the target end which
1707 # do not exist on the original end.
1708 rsync -ahvic "$@"
1709 }
1710 rst() {
1711 # rl without preserving modification time.
1712 rsync -ahvic --delete --no-t "$@"
1713 }
1714 # [RSYNC_OPTS] HOST PATH
1715 rsu() {
1716 # eg. rsu -opts frodo /testpath
1717 # relative paths will expanded with readlink -f.
1718 opts=("${@:1:$#-2}") # 1 to last -2
1719 path="${*:$#}" # last
1720 host="${*:$#-1:1}" # last -1
1721 if [[ $path == .* ]]; then
1722 path=$(readlink -f $path)
1723 fi
1724 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1725 }
1726 ccomp rsync rsd rsa rst rsu
1727
1728 # find programs listening on a port
1729 ssp() {
1730 local port=$1
1731 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1732 s ss -lpn state listening sport = $port
1733 }
1734
1735 resolvcat() {
1736 local f
1737 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1738 m s nscd -i hosts
1739 fi
1740 f=/etc/resolv.conf
1741 echo $f:; ccat $f
1742 hr; s ss -lpn sport = 53
1743 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1744 # this will fail is dnsmasq is failed
1745 hr; m ser status dnsmasq | cat || :
1746 f=/etc/dnsmasq.conf
1747 hr; echo $f:; ccat $f
1748 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1749 f=/etc/dnsmasq-servers.conf
1750 hr; echo $f:; ccat $f
1751 fi
1752 hr
1753 echo /etc/nsswitch.conf:
1754 grep '^ *hosts:' /etc/nsswitch.conf
1755 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1756 hr; m ser status systemd-resolved | cat || :
1757 hr; m resolvectl status | cat
1758 fi
1759
1760 }
1761 rcat() {
1762 resolvcat | less
1763 }
1764 reresolv() {
1765 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1766 m ser stop nscd
1767 sleep .5
1768 m ser start nscd
1769 m sudo nscd -i hosts
1770 fi
1771 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1772 m sudo systemctl restart dnsmasq
1773 fi
1774 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1775 m sudo systemctl restart systemd-resolved
1776 fi
1777 if type -P resolvectl &>/dev/null; then
1778 resolvectl flush-caches
1779 fi
1780 }
1781
1782 rmstrips() {
1783 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1784 }
1785
1786 urun () {
1787 umask $1
1788 shift
1789 "$@"
1790 }
1791 sudo () {
1792 command sudo "$@" || return $?
1793 DID_SUDO=true
1794 }
1795 s() {
1796 # background
1797 # I use a function because otherwise we cant use in a script,
1798 # cant assign to variable.
1799 #
1800 # note: gksudo is recommended for X apps because it does not set the
1801 # home directory to the same, and thus apps writing to ~ fuck things up
1802 # with root owned files.
1803 #
1804 if [[ $EUID != 0 || $1 == -* ]]; then
1805 # shellcheck disable=SC2034
1806 SUDOD="$PWD" command sudo -i "$@"
1807 DID_SUDO=true
1808 else
1809 "$@"
1810 fi
1811 }
1812 sb() { # sudo bash -c
1813 # use sb instead of s is for sudo redirections,
1814 # eg. sb 'echo "ok fine" > /etc/file'
1815 # shellcheck disable=SC2034
1816 local SUDOD="$PWD"
1817 sudo -i bash -c "$@"
1818 }
1819 # secret sudo
1820 se() { s urun 0077 "$@"; }
1821 ccomp sudo s sb se
1822
1823 safe_rename() { # warn and dont rename if file exists.
1824 # mv -n exists, but it\'s silent
1825 if [[ $# != 2 ]]; then
1826 echo safe_rename error: $# args, need 2 >2
1827 return 1
1828 fi
1829 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1830 if [[ -e $2 || -L $2 ]]; then
1831 echo "Cannot rename $1 to $2 as it already exists."
1832 else
1833 mv -vi "$1" "$2"
1834 fi
1835 fi
1836 }
1837
1838
1839 sd() {
1840 sudo dd status=none of="$1"
1841 }
1842
1843 ser() {
1844 if type -p systemctl &>/dev/null; then
1845 s systemctl "$@"
1846 else
1847 if (( $# >= 3 )); then
1848 echo iank: ser expected 2 or less arguments
1849 return 1
1850 fi
1851 s service $2 $1
1852 fi
1853 }
1854 serstat() {
1855 systemctl -n 40 status "$@"
1856 }
1857
1858 seru() { systemctl --user "$@"; }
1859 # like restart, but do nothing if its not already started
1860 srestart() {
1861 local service=$1
1862 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1863 systemctl restart $service
1864 fi
1865 }
1866
1867 setini() { # set a value in a .ini style file
1868 key="$1" value="$2" section="$3" file="$4"
1869 if [[ -s $file ]]; then
1870 sed -ri -f - "$file" <<EOF
1871 # remove existing keys
1872 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1873 # add key
1874 /^\s*\[$section\]/a $key=$value
1875 # from section to eof, do nothing
1876 /^\s*\[$section\]/,\$b
1877 # on the last line, if we haven't found section yet, add section and key
1878 \$a [$section]\\
1879 $key=$value
1880 EOF
1881 else
1882 cat >"$file" <<EOF
1883 [$section]
1884 $key=$value
1885 EOF
1886 fi
1887 }
1888
1889 sgo() { # service go
1890 service=$1
1891 ser restart $service || return 1
1892 if type -p systemctl &>/dev/null; then
1893 ser enable $service
1894 fi
1895 }
1896 soff () {
1897 for service; do
1898 # ignore services that dont exist
1899 if systemctl cat $service &>/dev/null; then
1900 ser stop $service;
1901 ser disable $service
1902 fi
1903 done
1904 }
1905
1906 sgu() {
1907 systemctl list-unit-files | rg "$@"
1908 }
1909
1910
1911 sk() {
1912
1913
1914 # disable a warning with:
1915 # shellcheck disable=SC2206 # reasoning
1916
1917 # see bash-template/style-guide.md for justifications
1918
1919 local quotes others
1920 quotes=2048,2068,2086,2206
1921 others=2029,2033,2054,2164
1922 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
1923 }
1924
1925
1926 # sl: ssh, but firsh rsync our bashrc and related files to a special
1927 # directory on the remote host if needed.
1928
1929 # Some environment variables and files need to be setup for this to work
1930 # (mine are set at the beginning of this file)
1931
1932 # SL_FILES_DIR: Environment variable. Path to folder which should at
1933 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1934 # remote hosts (top level symlinks are resolved) unless the host already
1935 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1936 # control and sync files to separately and already has the ~/.bashrc you
1937 # want. The remote bash will also take its .inputrc config from this
1938 # folder (default of not existing is fine). Mine looks like this:
1939 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1940
1941 # SL_INFO_DIR: Environment variable. This folder stores info about what
1942 # we detected on the remote system and when we last synced. It will be created
1943 # if it does not exist. Sometimes you may want to forget about a
1944 # remote system, you can use sl --rsync, or the function for that slr
1945 # below.
1946
1947 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1948 # depending on the remote host. Run this string on the remote host the
1949 # first time sl is run (or if we run slr). The result is passed to
1950 # SL_TEST_HOOK. For example,
1951 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1952
1953 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1954 # $SL_FILES_DIR to vary the files synced.
1955
1956 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1957 # example to exclude files within a directory. Note, excluded
1958 # files wont be deleted on rsync, you can add --delete-excluded
1959 # to the rsync command if that is desired.
1960
1961 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1962
1963 # For when ~/.bashrc is already customized on the remote server, you
1964 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1965 # commands, even in scripts. This paragraph is all about that. bash
1966 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1967 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1968 # and if you customize it, probably has bugs from time to time. This is
1969 # bad. Here's how I fix it. I have a special condition to "return" in my
1970 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1971 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1972 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1973 # separate file because even if I return early on, the whole file gets
1974 # parsed which can fail if there is a syntax error.
1975 sl() {
1976 # Background on LC_USEBASHRC var (no need to read if you just want to
1977 # use this function): env variables sent across ssh are strictly
1978 # limited, but we get LC_* at least in debian based machines, so we
1979 # just make that * be something no normal program would use. Note, on
1980 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1981 # set, and the inner shell also allows running a nondefault
1982 # .bashrc. This means the outer shell still ran the default .bashrc,
1983 # but that is the best we can do.
1984
1985 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1986 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1987 declare -a args tmpa
1988
1989 args=($SL_SSH_ARGS)
1990
1991 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1992 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1993 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1994 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1995 # [command]
1996
1997 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1998 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1999 # [-F configfile] [-I pkcs11] [-i identity_file]
2000 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
2001 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
2002 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
2003
2004 force_rsync=false
2005 if [[ $1 == --rsync ]]; then
2006 force_rsync=true
2007 shift
2008 fi
2009
2010 sl_test_cmd=$SL_TEST_CMD
2011 sl_test_hook=$SL_TEST_HOOK
2012 sl_rsync_args=$SL_RSYNC_ARGS
2013 while [[ $1 ]]; do
2014 case "$1" in
2015 --rsync)
2016 force_rsync=true
2017 ;;
2018 --sl-test-cmd)
2019 sl_test_cmd="$2"
2020 shift
2021 ;;
2022 --sl-test-hook)
2023 sl_test_hook="$2"
2024 shift
2025 ;;
2026 --sl-rsync-args)
2027 sl_rsync_args="$2"
2028 shift
2029 ;;
2030 *)
2031 break
2032 ;;
2033 esac
2034 shift
2035 done
2036
2037 while [[ $1 ]]; do
2038 case "$1" in
2039 # note we dont support things like -4oOption
2040 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2041 args+=("$1"); shift
2042 ;;
2043 -[bcDEeFIiJLlmOopQRSWw]*)
2044 # -oOption etc is valid
2045 if (( ${#1} >= 3 )); then
2046 args+=("$1"); shift
2047 else
2048 args+=("$1" "$2"); shift 2
2049 fi
2050 ;;
2051 *)
2052 break
2053 ;;
2054 esac
2055 done
2056 remote="$1"
2057 if [[ ! $remote ]]; then
2058 echo $0: error hostname required >&2
2059 return 1
2060 fi
2061 shift
2062
2063 if [[ ! $SL_INFO_DIR ]]; then
2064 echo error: missing '$SL_INFO_DIR' env var >&2
2065 return 1
2066 fi
2067
2068 dorsync=false
2069 haveinfo=false
2070 tmpa=($SL_INFO_DIR/???????????"$remote")
2071 sshinfo=${tmpa[0]}
2072 if [[ -e $sshinfo ]]; then
2073 if $force_rsync; then
2074 rm -f $sshinfo
2075 else
2076 haveinfo=true
2077 fi
2078 fi
2079 if $haveinfo; then
2080 tmp=${sshinfo[0]##*/}
2081 tmp2=${tmp::11}
2082 type=${tmp2: -1}
2083 extra_info=$(cat $sshinfo)
2084 else
2085 # we test for string to know ssh succeeded
2086 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2087 testcmd="if $testbool; then printf y; else printf n; fi"
2088 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2089 echo failed sl test. doing plain ssh -v
2090 command ssh -v "${args[@]}" "$remote"
2091 fi
2092 if [[ $tmp == y* ]]; then
2093 type=a
2094 else
2095 dorsync=true
2096 type=b
2097 fi
2098 extra_info="${tmp:1}"
2099 fi
2100 if [[ $sl_test_hook ]]; then
2101 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2102 fi
2103
2104 if $haveinfo && [[ $type == b ]]; then
2105 info_sec=${tmp::10}
2106 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2107 files_sec=${files_sec%%.*}
2108 if (( files_sec > info_sec )); then
2109 dorsync=true
2110 rm -f $sshinfo
2111 fi
2112 fi
2113
2114 sync_dirname=${SL_FILES_DIR##*/}
2115
2116 if [[ ! $SL_FILES_DIR ]]; then
2117 echo error: missing '$SL_FILES_DIR' env var >&2
2118 return 1
2119 fi
2120
2121 if $dorsync; then
2122 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2123 fi
2124 if $dorsync || ! $haveinfo; then
2125 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2126 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2127 printf "%s\n" "$extra_info" >$sshinfo
2128 chmod 666 $sshinfo
2129 fi
2130 if [[ $type == b ]]; then
2131 if (( ${#@} )); then
2132 # Theres a couple ways to pass arguments, im not sure whats best,
2133 # but relying on bash 4.4+ escape quoting seems most reliable.
2134 command ssh "${args[@]}" "$remote" \
2135 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2136 elif [[ ! -t 0 ]]; then
2137 # This case is when commands are being piped to ssh.
2138 # Normally, no bashrc gets sourced.
2139 # But, since we are doing all this, lets source it because we can.
2140 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2141 else
2142 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2143 fi
2144 else
2145 if [[ -t 0 ]]; then
2146 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2147 else
2148 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2149 fi
2150 fi
2151 # this function inspired from https://github.com/Russell91/sshrc
2152 }
2153
2154 slr() {
2155 sl --rsync "$@"
2156 }
2157 sss() { # ssh solo
2158 sl -oControlMaster=no -oControlPath=/ "$@"
2159 }
2160 # kill off old shared socket then ssh
2161 ssk() {
2162 m ssh -O exit "$@" || [[ $? == 255 ]]
2163 m sl "$@"
2164 }
2165 ccomp ssh sl slr sss ssk
2166 # plain ssh
2167 ssh() {
2168 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2169 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2170 else
2171 LC_USEBASHRC=t command ssh "$@"
2172 fi
2173 }
2174
2175
2176 slog() {
2177 # log with script. timing is $1.t and script is $1.s
2178 # -l to save to ~/typescripts/
2179 # -t to add a timestamp to the filenames
2180 local logdir do_stamp arg_base
2181 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2182 logdir="/a/dt/"
2183 do_stamp=false
2184 while getopts "lt" option
2185 do
2186 case $option in
2187 l ) arg_base=$logdir ;;
2188 t ) do_stamp=true ;;
2189 esac
2190 done
2191 shift $((OPTIND - 1))
2192 arg_base+=$1
2193 [[ -e $logdir ]] || mkdir -p $logdir
2194 $do_stamp && arg_base+=$(date +%F.%T%z)
2195 script -t $arg_base.s 2> $arg_base.t
2196 }
2197 splay() { # script replay
2198 #logRoot="$HOME/typescripts/"
2199 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2200 scriptreplay "$1.t" "$1.s"
2201 }
2202
2203 sr() {
2204 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2205 if [[ $# == 0 ]]; then
2206 sudo -E bash -c -l "$(history -p '!!')"
2207 else
2208 echo this command redos last history item. no argument is accepted
2209 fi
2210 }
2211
2212 srm () {
2213 # with -ll, less secure but faster.
2214 command srm -ll "$@"
2215 }
2216
2217 srun() {
2218 scp $2 $1:/tmp
2219 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
2220 }
2221
2222
2223 swap() {
2224 local tmp
2225 tmp=$(mktemp)
2226 mv $1 $tmp
2227 mv $2 $1
2228 mv $tmp $2
2229 }
2230
2231 tclock() { # terminal clock
2232 local x
2233 clear
2234 date +%l:%_M
2235 len=60
2236 # this goes to full width
2237 #len=${1:-$((COLUMNS -7))}
2238 x=1
2239 while true; do
2240 if (( x == len )); then
2241 end=true
2242 d="$(date +%l:%_M) "
2243 else
2244 end=false
2245 d=$(date +%l:%M:%_S)
2246 fi
2247 echo -en "\r"
2248 echo -n "$d"
2249 for ((i=0; i<x; i++)); do
2250 if (( i % 6 )); then
2251 echo -n _
2252 else
2253 echo -n .
2254 fi
2255 done
2256 if $end; then
2257 echo
2258 x=1
2259 else
2260 x=$((x+1))
2261 fi
2262 sleep 5
2263 done
2264 }
2265
2266
2267 te() {
2268 # test existence / exists
2269 local ret=0
2270 for x in "$@"; do
2271 [[ -e "$x" || -L "$x" ]] || ret=1
2272 done
2273 return $ret
2274 }
2275
2276 psoff() {
2277 # normally, i would just execute these commands in the function.
2278 # however, DEBUG is not inherited, so we need to run it outside a function.
2279 # And we want to run set -x afterwards to avoid spam, so we cram everything
2280 # in here, and then it will run after this function is done.
2281 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2282 }
2283 pson() {
2284 PROMPT_COMMAND=prompt-command
2285 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2286 trap 'settitle "$BASH_COMMAND"' DEBUG
2287 fi
2288 }
2289
2290 tx() { # toggle set -x, and the prompt so it doesnt spam
2291 if [[ $- == *x* ]]; then
2292 set +x
2293 pson
2294 else
2295 psoff
2296 fi
2297 }
2298
2299 psnetns() {
2300 # show all processes in the network namespace $1.
2301 # blank entries appear to be subprocesses/threads
2302 local x netns
2303 netns=$1
2304 ps -w | head -n 1
2305 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2306 while read -r l; do
2307 x=$(ps -w --no-headers -p $l);
2308 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2309 done
2310 }
2311 nonet() {
2312 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2313 s ip netns add nonet
2314 fi
2315 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2316 }
2317
2318 m() { printf "%s\n" "$*"; "$@"; }
2319
2320 # update file. note: duplicated in mail-setup
2321 u() {
2322 local tmp tmpdir dest="$1"
2323 local base="${dest##*/}"
2324 local dir="${dest%/*}"
2325 if [[ $dir != "$base" ]]; then
2326 # dest has a directory component
2327 mkdir -p "$dir"
2328 fi
2329 ur=false # u result
2330 tmpdir=$(mktemp -d)
2331 cat >$tmpdir/"$base"
2332 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2333 if [[ $tmp ]]; then
2334 printf "%s\n" "$tmp"
2335 ur=true
2336 if [[ $dest == /etc/systemd/system/* ]]; then
2337 reload=true
2338 fi
2339 fi
2340 rm -rf $tmpdir
2341 }
2342
2343
2344 uptime() {
2345 if type -p uprecords &>/dev/null; then
2346 uprecords -B
2347 else
2348 command uptime
2349 fi
2350 }
2351
2352 virshrm() {
2353 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2354 }
2355
2356 vm-set-listen(){
2357 local t
2358 t=$(mktemp)
2359 local vm=$1
2360 local ip=$2
2361 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2362 sed -r "s/listen='[^']+/listen='$ip/"> $t
2363 sudo virsh undefine $vm
2364 sudo virsh define $t
2365 }
2366
2367
2368 vmshare() {
2369 vm-set-listen $1 0.0.0.0
2370 }
2371
2372
2373 vmunshare() {
2374 vm-set-listen $1 127.0.0.1
2375 }
2376
2377 myiwscan() {
2378 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2379 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2380 sudo iw dev wls1 scan | sed -rn "
2381 s/^\Wcapability: (.*)/\1/;Ta;h;b
2382 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2383 # padded to min width of 20
2384 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2385 "|sort -r
2386 }
2387
2388 # Run script by copying it to a temporary location first,
2389 # and changing directory, so we don't have any open
2390 # directories or files that could cause problems when
2391 # remounting.
2392 z() {
2393 local tmp
2394 tmp=$(type -p "$1")
2395 if [[ $tmp ]]; then
2396 cd $(mktemp -d)
2397 cp -a "$tmp" .
2398 shift
2399 ./"${tmp##*/}" "$@"
2400 else
2401 "$@"
2402 fi
2403 }
2404
2405
2406 # * spark
2407 # spark 1 5 22 13 53
2408 # # => ▁▁▃▂▇
2409
2410 # The MIT License
2411 # Copyright (c) Zach Holman, https://zachholman.com
2412 # https://github.com/holman/spark
2413
2414 # As of 2022-10-28, I reviewed github forks that had several newer
2415 # commits, none had anything interesting. I did a little refactoring
2416 # mostly to fix emacs indent bug.
2417
2418 # Generates sparklines.
2419 _spark_echo()
2420 {
2421 if [ "X$1" = "X-n" ]; then
2422 shift
2423 printf "%s" "$*"
2424 else
2425 printf "%s\n" "$*"
2426 fi
2427 }
2428
2429
2430 spark()
2431 {
2432 local f tc
2433 local n numbers=
2434
2435 # find min/max values
2436 local min=0xffffffff max=0
2437
2438 for n in ${@//,/ }
2439 do
2440 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2441 # round the number but that doesn't work on OS X (bash3) nor does
2442 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2443 n=${n%.*}
2444 (( n < min )) && min=$n
2445 (( n > max )) && max=$n
2446 numbers=$numbers${numbers:+ }$n
2447 done
2448
2449 # print ticks
2450 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2451
2452 # use a high tick if data is constant
2453 (( min == max )) && ticks=(▅ ▆)
2454
2455 tc=${#ticks[@]}
2456 f=$(( ( (max-min) <<8)/( tc - 1) ))
2457 (( f < 1 )) && f=1
2458
2459 for n in $numbers
2460 do
2461 _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
2462 done
2463 _spark_echo
2464 }
2465
2466
2467 # * misc stuff
2468
2469
2470 if $use_color && type -p tput &>/dev/null; then
2471 term_bold="$(tput bold)"
2472 term_red="$(tput setaf 1)"
2473 term_green="$(tput setaf 2)"
2474 term_yellow="$(tput setaf 3)"
2475 term_purple="$(tput setaf 5)"
2476 term_nocolor="$(tput sgr0)" # no font attributes
2477
2478 # unused so far. commented for shellcheck
2479 # term_underl="$(tput smul)"
2480 # term_blue="$(tput setaf 4)"
2481 # term_cyan="$(tput setaf 6)"
2482 fi
2483 # Try to keep environment pollution down, EPA loves us.
2484 unset safe_term match_lhs use_color
2485
2486 # * prompt
2487
2488
2489 if [[ $- == *i* ]]; then
2490
2491
2492 case $HOSTNAME in
2493 bk|je|li)
2494 if [[ $EUID == 1000 ]]; then
2495 system-status _ ||:
2496 fi
2497 ;;
2498 esac
2499
2500
2501 # this needs to come before next ps1 stuff
2502 # this stuff needs bash 4, feb 2009,
2503 # old enough to no longer condition on $BASH_VERSION anymore
2504 shopt -s autocd
2505 shopt -s dirspell
2506 PS1='\w'
2507 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2508 PROMPT_DIRTRIM=2
2509 bind -m vi-command B:shell-backward-word
2510 bind -m vi-command W:shell-forward-word
2511 fi
2512
2513 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2514 unset PROMPT_DIRTRIM
2515 PS1="\h:$PS1"
2516 fi
2517
2518 # emacs terminal has problems if this runs slowly,
2519 # so I've thrown a bunch of things at the wall to speed it up.
2520 prompt-command() {
2521 local return=$? # this MUST COME FIRST
2522 local ps_char ps_color
2523 unset IFS
2524
2525 if [[ $HISTFILE ]]; then
2526 history -a # save history
2527 fi
2528
2529 case $return in
2530 0) ps_color="$term_purple"
2531 ps_char='\$'
2532 ;;
2533 *) ps_color="$term_green"
2534 ps_char="$return \\$"
2535 ;;
2536 esac
2537 if [[ ! -O . ]]; then # not owner
2538 if [[ -w . ]]; then # writable
2539 ps_color="$term_bold$term_red"
2540 else
2541 ps_color="$term_bold$term_green"
2542 fi
2543 fi
2544
2545 # faster than sourceing the file im guessing
2546 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2547 eval $(< /dev/shm/iank-status)
2548 fi
2549 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2550 ps_char="@ $ps_char"
2551 fi
2552 # We could test if sudo is active with sudo -nv
2553 # but then we get an email and log of lots of failed sudo commands.
2554 # We could turn those off, but seems better not to.
2555 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2556 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2557 fi
2558 if [[ ! $HISTFILE ]]; then
2559 ps_char="NOHIST $ps_char"
2560 fi
2561 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2562
2563 # set titlebar. instead, using more advanced
2564 # titelbar below
2565 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2566 }
2567 PROMPT_COMMAND=prompt-command
2568
2569 if [[ $TERM == screen* ]]; then
2570 _title_escape="\033]..2;"
2571 else
2572 # somme sites recommend this, i dunno what the diff is.
2573 #_title_escape="\033]30;"
2574 _title_escape="\033]0;"
2575 fi
2576
2577 settitle () {
2578 # this makes it so we show the current command if
2579 # one is running, otherwise, show nothing
2580
2581 if [[ $1 == prompt-command ]]; then
2582 return 0
2583 fi
2584 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2585 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2586 printf "%s" "$*"
2587 echo -ne "\007"
2588 fi
2589 }
2590
2591 # note, this wont work:
2592 # x=$(mktemp); cp a $x
2593 # I havnt figured out why, bigger fish to fry.
2594 #
2595 # for titlebar.
2596 # condition from the screen man page i think.
2597 # note: duplicated in tx()
2598 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2599 trap 'settitle "$BASH_COMMAND"' DEBUG
2600 else
2601 trap DEBUG
2602 fi
2603
2604 fi
2605
2606 # * stuff that makes sense to be at the end
2607
2608
2609 # best practice
2610 unset IFS
2611
2612 # shellcheck disable=SC1090
2613 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2614
2615 # I had this idea to start a bash shell which would run an initial
2616 # command passed through this env variable, then continue on
2617 # interactively. But the use case I had in mind went away.
2618 #
2619 # if [[ $MY_INIT_CMD ]]; then
2620 # "${MY_INIT_CMD[@]}"
2621 # unset MY_INIT_CMD
2622 # fi
2623
2624 # ensure no bad programs appending to this file will have an affect
2625 return 0